| Irrlicht 3D Engine |

Public Member Functions
irr::io::IAttributes Class Reference

Provides a generic interface for attributes and their values and the possiblity to serialize them. More...

`#include <IAttributes.h>`

Inheritance diagram for irr::io::IAttributes:

List of all members.

## Public Member Functions

- virtual void addArray (const c8 *attributeName, const core::array< core::stringw > &value)=0
    Adds an attribute as wide string array.
- virtual void addBinary (const c8 *attributeName, void *data, s32 dataSizeInBytes)=0
    Adds an attribute as binary data.
- virtual void addBool (const c8 *attributeName, bool value)=0
    Adds an attribute as bool.
- virtual void addBox3d (const c8 *attributeName, core::aabbox3df v)=0
    Adds an attribute as axis aligned bounding box.
- virtual void addColor (const c8 *attributeName, video::SColor value)=0
    Adds an attribute as color.
- virtual void addColorf (const c8 *attributeName, video::SColorf value)=0
    Adds an attribute as floating point color.
- virtual void addDimension2d (const c8 *attributeName, core::dimension2d< u32 > value)=0
    Adds an attribute as dimension2d.
- virtual void addEnum (const c8 *attributeName, const c8 *enumValue, const c8 *const *enumerationLiterals)=0
    Adds an attribute as enum.
- virtual void addEnum (const c8 *attributeName, s32 enumValue, const c8 *const *enumerationLiterals)=0
    Adds an attribute as enum.
- virtual void addFloat (const c8 *attributeName, f32 value)=0
    Adds an attribute as float.
- virtual void addInt (const c8 *attributeName, s32 value)=0
    Adds an attribute as integer.
- virtual void addLine2d (const c8 *attributeName, core::line2df v)=0
    Adds an attribute as a 2d line.
- virtual void addLine3d (const c8 *attributeName, core::line3df v)=0
    Adds an attribute as a 3d line.
- virtual void addMatrix (const c8 *attributeName, const core::matrix4 &v)=0
    Adds an attribute as matrix.
- virtual void addPlane3d (const c8 *attributeName, core::plane3df v)=0
    Adds an attribute as 3d plane.
- virtual void addPosition2d (const c8 *attributeName, core::position2di value)=0
    Adds an attribute as 2d position.
- virtual void addQuaternion (const c8 *attributeName, core::quaternion v)=0
    Adds an attribute as quaternion.
- virtual void addRect (const c8 *attributeName, core::rect< s32 > value)=0
    Adds an attribute as rectangle.
- virtual void addString (const c8 *attributeName, const c8 *value)=0
    Adds an attribute as string.
- virtual void addString (const c8 *attributeName, const wchar_t *value)=0
    Adds an attribute as string.
- virtual void addTexture (const c8 *attributeName, video::ITexture *texture, const io::path &filename="")=0
    Adds an attribute as texture reference.
- virtual void addTriangle3d (const c8 *attributeName, core::triangle3df v)=0
    Adds an attribute as 3d triangle.
- virtual void addUserPointer (const c8 *attributeName, void *userPointer)=0
    Adds an attribute as user pointner.
- virtual void addVector2d (const c8 *attributeName, core::vector2df value)=0
    Adds an attribute as 2d vector.
- virtual void addVector3d (const c8 *attributeName, core::vector3df value)=0
    Adds an attribute as 3d vector.
- virtual void clear ()=0
    Removes all attributes.
- virtual bool existsAttribute (const c8 *attributeName)=0
    Returns if an attribute with a name exists.
- virtual s32 findAttribute (const c8 *attributeName) const =0
    Returns attribute index from name, -1 if not found.
- virtual core::array
  < core::stringw > getAttributeAsArray (const c8 *attributeName)=0
- virtual core::array
  < core::stringw > getAttributeAsArray (s32 index)=0
- virtual void getAttributeAsBinaryData (const c8 *attributeName, void *outData, s32 maxSizeInBytes)=0
    Gets an attribute as binary data.
- virtual void getAttributeAsBinaryData (s32 index, void *outData, s32 maxSizeInBytes)=0
    Gets an attribute as binary data.
- virtual bool getAttributeAsBool (const c8 *attributeName)=0
- virtual bool getAttributeAsBool (s32 index)=0
- virtual core::aabbox3df getAttributeAsBox3d (const c8 *attributeName)=0
- virtual core::aabbox3df getAttributeAsBox3d (s32 index)=0
- virtual video::SColor getAttributeAsColor (const c8 *attributeName)=0
- virtual video::SColor getAttributeAsColor (s32 index)=0
- virtual video::SColorf getAttributeAsColorf (const c8 *attributeName)=0
- virtual video::SColorf getAttributeAsColorf (s32 index)=0
- virtual core::dimension2d< u32 > getAttributeAsDimension2d (const c8 *attributeName)=0
- virtual core::dimension2d< u32 > getAttributeAsDimension2d (s32 index)=0
- virtual const c8 * getAttributeAsEnumeration (const c8 *attributeName)=0
- virtual s32 getAttributeAsEnumeration (const c8 *attributeName, const c8 *const *enumerationLiteralsToUse)=0
    Gets an attribute as enumeration.
- virtual s32 getAttributeAsEnumeration (s32 index, const c8 *const *enumerationLiteralsToUse)=0
    Gets an attribute as enumeration.
- virtual const c8 * getAttributeAsEnumeration (s32 index)=0
- virtual f32 getAttributeAsFloat (const c8 *attributeName)=0
- virtual f32 getAttributeAsFloat (s32 index)=0
- virtual s32 getAttributeAsInt (const c8 *attributeName) const =0
- virtual s32 getAttributeAsInt (s32 index) const =0
- virtual core::line2df getAttributeAsLine2d (const c8 *attributeName)=0
- virtual core::line2df getAttributeAsLine2d (s32 index)=0
- virtual core::line3df getAttributeAsLine3d (const c8 *attributeName)=0
- virtual core::line3df getAttributeAsLine3d (s32 index)=0
- virtual core::matrix4 getAttributeAsMatrix (const c8 *attributeName)=0
- virtual core::matrix4 getAttributeAsMatrix (s32 index)=0
- virtual core::plane3df getAttributeAsPlane3d (const c8 *attributeName)=0
- virtual core::plane3df getAttributeAsPlane3d (s32 index)=0
- virtual core::position2di getAttributeAsPosition2d (const c8 *attributeName)=0
- virtual core::position2di getAttributeAsPosition2d (s32 index)=0
- virtual core::quaternion getAttributeAsQuaternion (const c8 *attributeName)=0
- virtual core::quaternion getAttributeAsQuaternion (s32 index)=0
- virtual core::rect< s32 > getAttributeAsRect (const c8 *attributeName)=0
- virtual core::rect< s32 > getAttributeAsRect (s32 index)=0
- virtual core::stringc getAttributeAsString (const c8 *attributeName)=0
- virtual void getAttributeAsString (const c8 *attributeName, c8 *target)=0
- virtual core::stringc getAttributeAsString (s32 index)=0
- virtual core::stringw getAttributeAsStringW (const c8 *attributeName)=0
- virtual void getAttributeAsStringW (const c8 *attributeName, wchar_t *target)=0
- virtual core::stringw getAttributeAsStringW (s32 index)=0
- virtual video::ITexture * getAttributeAsTexture (const c8 *attributeName)=0
- virtual video::ITexture * getAttributeAsTexture (s32 index)=0
- virtual core::triangle3df getAttributeAsTriangle3d (const c8 *attributeName)=0
- virtual core::triangle3df getAttributeAsTriangle3d (s32 index)=0
- virtual void * getAttributeAsUserPointer (const c8 *attributeName)=0
- virtual void * getAttributeAsUserPointer (s32 index)=0
- virtual core::vector2df getAttributeAsVector2d (const c8 *attributeName)=0
- virtual core::vector2df getAttributeAsVector2d (s32 index)=0
- virtual core::vector3df getAttributeAsVector3d (const c8 *attributeName)=0
- virtual core::vector3df getAttributeAsVector3d (s32 index)=0
- virtual u32 getAttributeCount () const =0
    Returns amount of attributes in this collection of attributes.
- virtual void getAttributeEnumerationLiteralsOfEnumeration (const c8 *attributeName, core::array< core::stringc > &outLiterals)=0
- virtual void getAttributeEnumerationLiteralsOfEnumeration (s32 index, core::array< core::stringc > &outLiterals)=0
- virtual const c8 * getAttributeName (s32 index)=0
- virtual E_ATTRIBUTE_TYPE getAttributeType (const c8 *attributeName)=0
- virtual E_ATTRIBUTE_TYPE getAttributeType (s32 index)=0
- virtual const wchar_t * getAttributeTypeString (const c8 *attributeName)=0
- virtual const wchar_t * getAttributeTypeString (s32 index)=0
- virtual bool read (io::IXMLReader *reader, bool readCurrentElementOnly=false, const wchar_t *elementName=0)=0
- virtual void setAttribute (const c8 *attributeName, s32 value)=0
    Sets an attribute as integer value.
- virtual void setAttribute (s32 index, s32 value)=0
    Sets an attribute as integer value.
- virtual void setAttribute (const c8 *attributeName, f32 value)=0
    Sets a attribute as float value.
- virtual void setAttribute (s32 index, f32 value)=0
    Sets an attribute as float value.
- virtual void setAttribute (const c8 *attributeName, const c8 *value)=0
- virtual void setAttribute (s32 index, const c8 *value)=0
- virtual void setAttribute (const c8 *attributeName, const wchar_t *value)=0
- virtual void setAttribute (s32 index, const wchar_t *value)=0
- virtual void setAttribute (const c8 *attributeName, void *data, s32 dataSizeInBytes)=0
    Sets an attribute as binary data.
- virtual void setAttribute (s32 index, void *data, s32 dataSizeInBytes)=0
    Sets an attribute as binary data.
- virtual void setAttribute (const c8 *attributeName, const core::array< core::stringw > &value)=0
- virtual void setAttribute (s32 index, const core::array< core::stringw > &value)=0
    Sets an attribute as an array of wide strings.
- virtual void setAttribute (const c8 *attributeName, bool value)=0
    Sets an attribute as boolean value.
- virtual void setAttribute (s32 index, bool value)=0
    Sets an attribute as boolean value.
- virtual void setAttribute (const c8 *attributeName, const c8 *enumValue, const c8 *const *enumerationLiterals)=0
    Sets an attribute as enumeration.
- virtual void setAttribute (s32 index, const c8 *enumValue, const c8 *const *enumerationLiterals)=0
    Sets an attribute as enumeration.
- virtual void setAttribute (const c8 *attributeName, video::SColor color)=0
    Sets a attribute as color.
- virtual void setAttribute (s32 index, video::SColor color)=0
    Sets an attribute as color.
- virtual void setAttribute (const c8 *attributeName, video::SColorf color)=0
    Sets a attribute as floating point color.
- virtual void setAttribute (s32 index, video::SColorf color)=0
    Sets an attribute as floating point color.
- virtual void setAttribute (const c8 *attributeName, core::vector3df v)=0
    Sets a attribute as 3d vector.
- virtual void setAttribute (s32 index, core::vector3df v)=0
    Sets an attribute as vector.
- virtual void setAttribute (const c8 *attributeName, core::vector2df v)=0
    Sets a attribute as 2d vector.
- virtual void setAttribute (s32 index, core::vector2df v)=0
    Sets an attribute as 2d vector.
- virtual void setAttribute (const c8 *attributeName, core::position2di v)=0
    Sets a attribute as 2d position.
- virtual void setAttribute (s32 index, core::position2di v)=0
    Sets an attribute as 2d position.
- virtual void setAttribute (const c8 *attributeName, core::rect< s32 > v)=0
    Sets an attribute as rectangle.
- virtual void setAttribute (s32 index, core::rect< s32 > v)=0
    Sets an attribute as rectangle.
- virtual void setAttribute (const c8 *attributeName, core::dimension2d< u32 > v)=0
    Sets an attribute as dimension2d.
- virtual void setAttribute (s32 index, core::dimension2d< u32 > v)=0
    Sets an attribute as dimension2d.
- virtual void setAttribute (const c8 *attributeName, const core::matrix4 &v)=0
    Sets an attribute as matrix.
- virtual void setAttribute (s32 index, const core::matrix4 &v)=0
    Sets an attribute as matrix.
- virtual void setAttribute (const c8 *attributeName, core::quaternion v)=0
    Sets an attribute as quaternion.
- virtual void setAttribute (s32 index, core::quaternion v)=0
    Sets an attribute as quaternion.
- virtual void setAttribute (const c8 *attributeName, core::aabbox3df v)=0
    Sets an attribute as axis aligned bounding box.
- virtual void setAttribute (s32 index, core::aabbox3df v)=0
    Sets an attribute as axis aligned bounding box.
- virtual void setAttribute (const c8 *attributeName, core::plane3df v)=0
    Sets an attribute as 3d plane.
- virtual void setAttribute (s32 index, core::plane3df v)=0
    Sets an attribute as 3d plane.
- virtual void setAttribute (const c8 *attributeName, core::triangle3df v)=0
    Sets an attribute as 3d trianle.
- virtual void setAttribute (s32 index, core::triangle3df v)=0
    Sets an attribute as 3d triangle.
- virtual void setAttribute (const c8 *attributeName, core::line2df v)=0
    Sets an attribute as a 2d line.
- virtual void setAttribute (s32 index, core::line2df v)=0
    Sets an attribute as a 2d line.
- virtual void setAttribute (const c8 *attributeName, core::line3df v)=0
    Sets an attribute as a 3d line.
- virtual void setAttribute (s32 index, core::line3df v)=0
    Sets an attribute as a 3d line.
- virtual void setAttribute (const c8 *attributeName, video::ITexture *texture, const io::path &filename="")=0
    Sets an attribute as texture reference.
- virtual void setAttribute (s32 index, video::ITexture *texture, const io::path &filename="")=0
    Sets an attribute as texture reference.
- virtual void setAttribute (const c8 *attributeName, void *userPointer)=0
    Sets an attribute as user pointer.
- virtual void setAttribute (s32 index, void *userPointer)=0
    Sets an attribute as user pointer.
- virtual bool write (io::IXMLWriter *writer, bool writeXMLHeader=false, const wchar_t *elementName=0)=0

## Detailed Description

Provides a generic interface for attributes and their values and the possiblity to serialize them.

Definition at line 41 of file IAttributes.h.

## Member Function Documentation

virtual void irr::io::IAttributes::addArray | ( | const c8 * | attributeName,
|  | const core::array< core::stringw > & | value
| ) |  | `[pure virtual]`

Adds an attribute as wide string array.

virtual void irr::io::IAttributes::addBinary | ( | const c8 * | attributeName,
|  | void * | data,
|  | s32 | dataSizeInBytes
| ) |  | `[pure virtual]`

Adds an attribute as binary data.

virtual void irr::io::IAttributes::addBool | ( | const c8 * | attributeName,
|  | bool | value
| ) |  | `[pure virtual]`

Adds an attribute as bool.

Referenced by irr::scene::ICameraSceneNode::serializeAttributes(), irr::scene::ISceneNode::serializeAttributes(), and irr::gui::IGUIElement::serializeAttributes().

virtual void irr::io::IAttributes::addBox3d | ( | const c8 * | attributeName,
|  | core::aabbox3df | v
| ) |  | `[pure virtual]`

Adds an attribute as axis aligned bounding box.

virtual void irr::io::IAttributes::addColor | ( | const c8 * | attributeName,
|  | video::SColor | value
| ) |  | `[pure virtual]`

Adds an attribute as color.

virtual void irr::io::IAttributes::addColorf | ( | const c8 * | attributeName,
|  | video::SColorf | value
| ) |  | `[pure virtual]`

Adds an attribute as floating point color.

virtual void irr::io::IAttributes::addDimension2d | ( | const c8 * | attributeName,
|  | core::dimension2d< u32 > | value
| ) |  | `[pure virtual]`

Adds an attribute as dimension2d.

virtual void irr::io::IAttributes::addEnum | ( | const c8 * | attributeName,
|  | const c8 * | enumValue,
|  | const c8 *const * | enumerationLiterals
| ) |  | `[pure virtual]`

Adds an attribute as enum.

Referenced by irr::gui::IGUIElement::serializeAttributes().

virtual void irr::io::IAttributes::addEnum | ( | const c8 * | attributeName,
|  | s32 | enumValue,
|  | const c8 *const * | enumerationLiterals
| ) |  | `[pure virtual]`

Adds an attribute as enum.

virtual void irr::io::IAttributes::addFloat | ( | const c8 * | attributeName,
|  | f32 | value
| ) |  | `[pure virtual]`

Adds an attribute as float.

virtual void irr::io::IAttributes::addInt | ( | const c8 * | attributeName,
|  | s32 | value
| ) |  | `[pure virtual]`

Adds an attribute as integer.

Referenced by irr::scene::ISceneNode::serializeAttributes(), and irr::gui::IGUIElement::serializeAttributes().

virtual void irr::io::IAttributes::addLine2d | ( | const c8 * | attributeName,
|  | core::line2df | v
| ) |  | `[pure virtual]`

Adds an attribute as a 2d line.

virtual void irr::io::IAttributes::addLine3d | ( | const c8 * | attributeName,
|  | core::line3df | v
| ) |  | `[pure virtual]`

Adds an attribute as a 3d line.

virtual void irr::io::IAttributes::addMatrix | ( | const c8 * | attributeName,
|  | const core::matrix4 & | v
| ) |  | `[pure virtual]`

Adds an attribute as matrix.

virtual void irr::io::IAttributes::addPlane3d | ( | const c8 * | attributeName,
|  | core::plane3df | v
| ) |  | `[pure virtual]`

Adds an attribute as 3d plane.

virtual void irr::io::IAttributes::addPosition2d | ( | const c8 * | attributeName,
|  | core::position2di | value
| ) |  | `[pure virtual]`

Adds an attribute as 2d position.

Referenced by irr::gui::IGUIElement::serializeAttributes().

virtual void irr::io::IAttributes::addQuaternion | ( | const c8 * | attributeName,
|  | core::quaternion | v
| ) |  | `[pure virtual]`

Adds an attribute as quaternion.

virtual void irr::io::IAttributes::addRect | ( | const c8 * | attributeName,
|  | core::rect< s32 > | value
| ) |  | `[pure virtual]`

Adds an attribute as rectangle.

Referenced by irr::gui::IGUIElement::serializeAttributes().

virtual void irr::io::IAttributes::addString | ( | const c8 * | attributeName,
|  | const c8 * | value
| ) |  | `[pure virtual]`

Adds an attribute as string.

Referenced by irr::scene::ISceneNode::serializeAttributes(), and irr::gui::IGUIElement::serializeAttributes().

virtual void irr::io::IAttributes::addString | ( | const c8 * | attributeName,
|  | const wchar_t * | value
| ) |  | `[pure virtual]`

Adds an attribute as string.

virtual void irr::io::IAttributes::addTexture | ( | const c8 * | attributeName,
|  | video::ITexture * | texture,
|  | const io::path & | filename = `""`
| ) |  | `[pure virtual]`

Adds an attribute as texture reference.

virtual void irr::io::IAttributes::addTriangle3d | ( | const c8 * | attributeName,
|  | core::triangle3df | v
| ) |  | `[pure virtual]`

Adds an attribute as 3d triangle.

virtual void irr::io::IAttributes::addUserPointer | ( | const c8 * | attributeName,
|  | void * | userPointer
| ) |  | `[pure virtual]`

Adds an attribute as user pointner.

virtual void irr::io::IAttributes::addVector2d | ( | const c8 * | attributeName,
|  | core::vector2df | value
| ) |  | `[pure virtual]`

Adds an attribute as 2d vector.

virtual void irr::io::IAttributes::addVector3d | ( | const c8 * | attributeName,
|  | core::vector3df | value
| ) |  | `[pure virtual]`

Adds an attribute as 3d vector.

Referenced by irr::scene::ISceneNode::serializeAttributes().

virtual void irr::io::IAttributes::clear | ( |  | ) | `[pure virtual]`

Removes all attributes.

virtual bool irr::io::IAttributes::existsAttribute | ( | const c8 * | attributeName | ) | `[pure virtual]`

Returns if an attribute with a name exists.

virtual s32 irr::io::IAttributes::findAttribute | ( | const c8 * | attributeName | ) | const`[pure virtual]`

Returns attribute index from name, -1 if not found.

Referenced by irr::scene::ICameraSceneNode::deserializeAttributes().

virtual core::array<core::stringw> irr::io::IAttributes::getAttributeAsArray | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as an array of wide strings.

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute() or 0 if attribute is not set.

virtual core::array<core::stringw> irr::io::IAttributes::getAttributeAsArray | ( | s32 | index | ) | `[pure virtual]`

Returns attribute value as an array of wide strings by index.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual void irr::io::IAttributes::getAttributeAsBinaryData | ( | const c8 * | attributeName,
|  | void * | outData,
|  | s32 | maxSizeInBytes
| ) |  | `[pure virtual]`

Gets an attribute as binary data.

Parameters:

  attributeName,: | Name of the attribute to get.
  outData | Pointer to buffer where data shall be stored.
  maxSizeInBytes | Maximum number of bytes to write into outData.

virtual void irr::io::IAttributes::getAttributeAsBinaryData | ( | s32 | index,
|  | void * | outData,
|  | s32 | maxSizeInBytes
| ) |  | `[pure virtual]`

Gets an attribute as binary data.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.
  outData | Pointer to buffer where data shall be stored.
  maxSizeInBytes | Maximum number of bytes to write into outData.

virtual bool irr::io::IAttributes::getAttributeAsBool | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as boolean value

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

Referenced by irr::scene::ICameraSceneNode::deserializeAttributes(), irr::scene::ISceneNode::deserializeAttributes(), and irr::gui::IGUIElement::deserializeAttributes().

virtual bool irr::io::IAttributes::getAttributeAsBool | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as boolean value

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::aabbox3df irr::io::IAttributes::getAttributeAsBox3d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a axis aligned bounding box

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::aabbox3df irr::io::IAttributes::getAttributeAsBox3d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as axis aligned bounding box

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual video::SColor irr::io::IAttributes::getAttributeAsColor | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as color

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual video::SColor irr::io::IAttributes::getAttributeAsColor | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as color

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual video::SColorf irr::io::IAttributes::getAttributeAsColorf | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as floating point color

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual video::SColorf irr::io::IAttributes::getAttributeAsColorf | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as floating point color

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::dimension2d<u32> irr::io::IAttributes::getAttributeAsDimension2d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as dimension2d

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::dimension2d<u32> irr::io::IAttributes::getAttributeAsDimension2d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as dimension2d

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual const c8* irr::io::IAttributes::getAttributeAsEnumeration | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as enumeration

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

Referenced by irr::scene::ISceneNode::deserializeAttributes(), and irr::gui::IGUIElement::deserializeAttributes().

virtual s32 irr::io::IAttributes::getAttributeAsEnumeration | ( | const c8 * | attributeName,
|  | const c8 *const * | enumerationLiteralsToUse
| ) |  | `[pure virtual]`

Gets an attribute as enumeration.

Parameters:

  attributeName,: | Name of the attribute to get.
  enumerationLiteralsToUse,: | Use these enumeration literals to get the index value instead of the set ones. This is useful when the attribute list maybe was read from an xml file, and only contains the enumeration string, but no information about its index.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual s32 irr::io::IAttributes::getAttributeAsEnumeration | ( | s32 | index,
|  | const c8 *const * | enumerationLiteralsToUse
| ) |  | `[pure virtual]`

Gets an attribute as enumeration.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.
  enumerationLiteralsToUse,: | Use these enumeration literals to get the index value instead of the set ones. This is useful when the attribute list maybe was read from an xml file, and only contains the enumeration string, but no information about its index.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual const c8* irr::io::IAttributes::getAttributeAsEnumeration | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as enumeration

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual f32 irr::io::IAttributes::getAttributeAsFloat | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as float value

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual f32 irr::io::IAttributes::getAttributeAsFloat | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as float value

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual s32 irr::io::IAttributes::getAttributeAsInt | ( | const c8 * | attributeName | ) | const`[pure virtual]`

Gets an attribute as integer value

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

Referenced by irr::scene::ISceneNode::deserializeAttributes(), and irr::gui::IGUIElement::deserializeAttributes().

virtual s32 irr::io::IAttributes::getAttributeAsInt | ( | s32 | index | ) | const`[pure virtual]`

Gets an attribute as integer value

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::line2df irr::io::IAttributes::getAttributeAsLine2d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a 2d line

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::line2df irr::io::IAttributes::getAttributeAsLine2d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as a 2d line

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::line3df irr::io::IAttributes::getAttributeAsLine3d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a 3d line

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::line3df irr::io::IAttributes::getAttributeAsLine3d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as a 3d line

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::matrix4 irr::io::IAttributes::getAttributeAsMatrix | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a matrix4

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::matrix4 irr::io::IAttributes::getAttributeAsMatrix | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as matrix

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::plane3df irr::io::IAttributes::getAttributeAsPlane3d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a 3d plane

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::plane3df irr::io::IAttributes::getAttributeAsPlane3d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as 3d plane

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::position2di irr::io::IAttributes::getAttributeAsPosition2d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as position

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

Referenced by irr::gui::IGUIElement::deserializeAttributes().

virtual core::position2di irr::io::IAttributes::getAttributeAsPosition2d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as position

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::quaternion irr::io::IAttributes::getAttributeAsQuaternion | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a quaternion

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::quaternion irr::io::IAttributes::getAttributeAsQuaternion | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as quaternion

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::rect<s32> irr::io::IAttributes::getAttributeAsRect | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as rectangle

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

Referenced by irr::gui::IGUIElement::deserializeAttributes().

virtual core::rect<s32> irr::io::IAttributes::getAttributeAsRect | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as rectangle

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::stringc irr::io::IAttributes::getAttributeAsString | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as string.

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute() or 0 if attribute is not set.

Referenced by irr::scene::ISceneNode::deserializeAttributes(), and irr::gui::IGUIElement::deserializeAttributes().

virtual void irr::io::IAttributes::getAttributeAsString | ( | const c8 * | attributeName,
|  | c8 * | target
| ) |  | `[pure virtual]`

Gets an attribute as string.

Parameters:

  attributeName | Name of the attribute to get.
  target | Buffer where the string is copied to.

virtual core::stringc irr::io::IAttributes::getAttributeAsString | ( | s32 | index | ) | `[pure virtual]`

Returns attribute value as string by index.

Parameters:

  index | Index value, must be between 0 and getAttributeCount()-1.

virtual core::stringw irr::io::IAttributes::getAttributeAsStringW | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as string.

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute() or 0 if attribute is not set.

Referenced by irr::gui::IGUIElement::deserializeAttributes().

virtual void irr::io::IAttributes::getAttributeAsStringW | ( | const c8 * | attributeName,
|  | wchar_t * | target
| ) |  | `[pure virtual]`

Gets an attribute as string.

Parameters:

  attributeName,: | Name of the attribute to get.
  target,: | Buffer where the string is copied to.

virtual core::stringw irr::io::IAttributes::getAttributeAsStringW | ( | s32 | index | ) | `[pure virtual]`

Returns attribute value as string by index.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual video::ITexture* irr::io::IAttributes::getAttributeAsTexture | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as texture reference

Parameters:

  attributeName,: | Name of the attribute to get.

virtual video::ITexture* irr::io::IAttributes::getAttributeAsTexture | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as texture reference

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::triangle3df irr::io::IAttributes::getAttributeAsTriangle3d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as a 3d triangle

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::triangle3df irr::io::IAttributes::getAttributeAsTriangle3d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as 3d triangle

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual void* irr::io::IAttributes::getAttributeAsUserPointer | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as user pointer

Parameters:

  attributeName,: | Name of the attribute to get.

virtual void* irr::io::IAttributes::getAttributeAsUserPointer | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as user pointer

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::vector2df irr::io::IAttributes::getAttributeAsVector2d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as vector

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

virtual core::vector2df irr::io::IAttributes::getAttributeAsVector2d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as position

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual core::vector3df irr::io::IAttributes::getAttributeAsVector3d | ( | const c8 * | attributeName | ) | `[pure virtual]`

Gets an attribute as 3d vector

Parameters:

  attributeName,: | Name of the attribute to get.

Returns:
  Returns value of the attribute previously set by setAttribute()

Referenced by irr::scene::ISceneNode::deserializeAttributes().

virtual core::vector3df irr::io::IAttributes::getAttributeAsVector3d | ( | s32 | index | ) | `[pure virtual]`

Gets an attribute as 3d vector

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual u32 irr::io::IAttributes::getAttributeCount | ( |  | ) | const`[pure virtual]`

Returns amount of attributes in this collection of attributes.

virtual void irr::io::IAttributes::getAttributeEnumerationLiteralsOfEnumeration | ( | const c8 * | attributeName,
|  | core::array< core::stringc > & | outLiterals
| ) |  | `[pure virtual]`

Gets the list of enumeration literals of an enumeration attribute

Parameters:

  attributeName | Name of the attribute to get.
  outLiterals | Set of strings to choose the enum name from.

virtual void irr::io::IAttributes::getAttributeEnumerationLiteralsOfEnumeration | ( | s32 | index,
|  | core::array< core::stringc > & | outLiterals
| ) |  | `[pure virtual]`

Gets the list of enumeration literals of an enumeration attribute

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.
  outLiterals | Set of strings to choose the enum name from.

virtual const c8* irr::io::IAttributes::getAttributeName | ( | s32 | index | ) | `[pure virtual]`

Returns attribute name by index.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual E_ATTRIBUTE_TYPE irr::io::IAttributes::getAttributeType | ( | const c8 * | attributeName | ) | `[pure virtual]`

Returns the type of an attribute

Parameters:

  attributeName,: | Name for the attribute

virtual E_ATTRIBUTE_TYPE irr::io::IAttributes::getAttributeType | ( | s32 | index | ) | `[pure virtual]`

Returns attribute type by index.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual const wchar_t* irr::io::IAttributes::getAttributeTypeString | ( | const c8 * | attributeName | ) | `[pure virtual]`

Returns the type string of the attribute

Parameters:

  attributeName,: | String for the attribute type

virtual const wchar_t* irr::io::IAttributes::getAttributeTypeString | ( | s32 | index | ) | `[pure virtual]`

Returns the type string of the attribute by index.

Parameters:

  index,: | Index value, must be between 0 and getAttributeCount()-1.

virtual bool irr::io::IAttributes::read | ( | io::IXMLReader * | reader,
|  | bool | readCurrentElementOnly = `false`,
|  | const wchar_t * | elementName = `0`
| ) |  | `[pure virtual]`

Reads attributes from a xml file.

Parameters:

  reader | The XML reader to read from
  readCurrentElementOnly | If set to true, reading only works if current element has the name 'attributes' or the name specified using elementName.
  elementName | The surrounding element name. If it is null, the default one, "attributes" will be taken. If set to false, the first appearing list of attributes are read.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | s32 | value
| ) |  | `[pure virtual]`

Sets an attribute as integer value.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | s32 | value
| ) |  | `[pure virtual]`

Sets an attribute as integer value.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | f32 | value
| ) |  | `[pure virtual]`

Sets a attribute as float value.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | f32 | value
| ) |  | `[pure virtual]`

Sets an attribute as float value.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | const c8 * | value
| ) |  | `[pure virtual]`

Sets an attribute value as string.

Parameters:

  attributeName,: | Name for the attribute
  value,: | Value for the attribute. Set this to 0 to delete the attribute

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | const c8 * | value
| ) |  | `[pure virtual]`

Sets an attribute value as string.

Parameters:

  index | Index value, must be between 0 and getAttributeCount()-1.
  value | String to which the attribute is set.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | const wchar_t * | value
| ) |  | `[pure virtual]`

Sets an attribute value as string.

Parameters:

  attributeName,: | Name for the attribute
  value,: | Value for the attribute. Set this to 0 to delete the attribute

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | const wchar_t * | value
| ) |  | `[pure virtual]`

Sets an attribute value as string.

Parameters:

  index | Index value, must be between 0 and getAttributeCount()-1.
  value | String to which the attribute is set.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | void * | data,
|  | s32 | dataSizeInBytes
| ) |  | `[pure virtual]`

Sets an attribute as binary data.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | void * | data,
|  | s32 | dataSizeInBytes
| ) |  | `[pure virtual]`

Sets an attribute as binary data.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | const core::array< core::stringw > & | value
| ) |  | `[pure virtual]`

Sets an attribute value as a wide string array.

Parameters:

  attributeName,: | Name for the attribute
  value,: | Value for the attribute. Set this to 0 to delete the attribute

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | const core::array< core::stringw > & | value
| ) |  | `[pure virtual]`

Sets an attribute as an array of wide strings.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | bool | value
| ) |  | `[pure virtual]`

Sets an attribute as boolean value.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | bool | value
| ) |  | `[pure virtual]`

Sets an attribute as boolean value.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | const c8 * | enumValue,
|  | const c8 *const * | enumerationLiterals
| ) |  | `[pure virtual]`

Sets an attribute as enumeration.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | const c8 * | enumValue,
|  | const c8 *const * | enumerationLiterals
| ) |  | `[pure virtual]`

Sets an attribute as enumeration.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | video::SColor | color
| ) |  | `[pure virtual]`

Sets a attribute as color.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | video::SColor | color
| ) |  | `[pure virtual]`

Sets an attribute as color.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | video::SColorf | color
| ) |  | `[pure virtual]`

Sets a attribute as floating point color.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | video::SColorf | color
| ) |  | `[pure virtual]`

Sets an attribute as floating point color.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::vector3df | v
| ) |  | `[pure virtual]`

Sets a attribute as 3d vector.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::vector3df | v
| ) |  | `[pure virtual]`

Sets an attribute as vector.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::vector2df | v
| ) |  | `[pure virtual]`

Sets a attribute as 2d vector.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::vector2df | v
| ) |  | `[pure virtual]`

Sets an attribute as 2d vector.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::position2di | v
| ) |  | `[pure virtual]`

Sets a attribute as 2d position.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::position2di | v
| ) |  | `[pure virtual]`

Sets an attribute as 2d position.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::rect< s32 > | v
| ) |  | `[pure virtual]`

Sets an attribute as rectangle.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::rect< s32 > | v
| ) |  | `[pure virtual]`

Sets an attribute as rectangle.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::dimension2d< u32 > | v
| ) |  | `[pure virtual]`

Sets an attribute as dimension2d.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::dimension2d< u32 > | v
| ) |  | `[pure virtual]`

Sets an attribute as dimension2d.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | const core::matrix4 & | v
| ) |  | `[pure virtual]`

Sets an attribute as matrix.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | const core::matrix4 & | v
| ) |  | `[pure virtual]`

Sets an attribute as matrix.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::quaternion | v
| ) |  | `[pure virtual]`

Sets an attribute as quaternion.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::quaternion | v
| ) |  | `[pure virtual]`

Sets an attribute as quaternion.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::aabbox3df | v
| ) |  | `[pure virtual]`

Sets an attribute as axis aligned bounding box.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::aabbox3df | v
| ) |  | `[pure virtual]`

Sets an attribute as axis aligned bounding box.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::plane3df | v
| ) |  | `[pure virtual]`

Sets an attribute as 3d plane.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::plane3df | v
| ) |  | `[pure virtual]`

Sets an attribute as 3d plane.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::triangle3df | v
| ) |  | `[pure virtual]`

Sets an attribute as 3d trianle.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::triangle3df | v
| ) |  | `[pure virtual]`

Sets an attribute as 3d triangle.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::line2df | v
| ) |  | `[pure virtual]`

Sets an attribute as a 2d line.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::line2df | v
| ) |  | `[pure virtual]`

Sets an attribute as a 2d line.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | core::line3df | v
| ) |  | `[pure virtual]`

Sets an attribute as a 3d line.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | core::line3df | v
| ) |  | `[pure virtual]`

Sets an attribute as a 3d line.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | video::ITexture * | texture,
|  | const io::path & | filename = `""`
| ) |  | `[pure virtual]`

Sets an attribute as texture reference.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | video::ITexture * | texture,
|  | const io::path & | filename = `""`
| ) |  | `[pure virtual]`

Sets an attribute as texture reference.

virtual void irr::io::IAttributes::setAttribute | ( | const c8 * | attributeName,
|  | void * | userPointer
| ) |  | `[pure virtual]`

Sets an attribute as user pointer.

virtual void irr::io::IAttributes::setAttribute | ( | s32 | index,
|  | void * | userPointer
| ) |  | `[pure virtual]`

Sets an attribute as user pointer.

virtual bool irr::io::IAttributes::write | ( | io::IXMLWriter * | writer,
|  | bool | writeXMLHeader = `false`,
|  | const wchar_t * | elementName = `0`
| ) |  | `[pure virtual]`

Write these attributes into a xml file

Parameters:

  writer,: | The XML writer to write to
  writeXMLHeader,: | Writes a header to the XML file, required if at the beginning of the file
  elementName,: | The surrounding element name. If it is null, the default one, "attributes" will be taken.

The documentation for this class was generated from the following file:

- IAttributes.h